#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include "environ.h"

int chk_raindrop()
{
	const char func_name[]="chk_raindrop()";
	FILE	*fp;
	DIR	*dir;
	int	sensor1,sensor2;
	char	buf[ENV_MSGLEN],fname[ENV_MSGLEN],msg[ENV_MSGLEN];

	if((dir=opendir(WEATHER_DIR))==NULL)
	{
		sprintf(msg,"%s: Directory not found.",func_name);
		fprintf(stderr,msg);
		return ENV_ERR;
	}
	closedir(dir);

	sprintf(fname,"%s/%s",WEATHER_DIR,RAINDROP_FILE);
	if((fp=fopen(fname,"rt"))==NULL)
	{
		sprintf(msg,"%s: File open error.",func_name);
		fprintf(stderr,msg);
		return ENV_ERR;
	}

	fgets(buf,sizeof(buf),fp);
	fclose(fp);
	if(sscanf(buf,"1=%d,2=%d",&sensor1,&sensor2)!=2)
	{
		sprintf(msg,"%s: File format error.",func_name);
		fprintf(stderr,msg);
		return ENV_ERR;
	}

	if(sensor1==RAIN_FALSE && sensor2==RAIN_FALSE)
		return RAIN_FALSE;
	else
		return RAIN_TRUE;
}

int chk_raindrop_msg(char rmsg[])
{
	const char func_name[]="chk_raindrop()";
	FILE	*fp;
	DIR	*dir;
	int	sensor1,sensor2;
	char	buf[ENV_MSGLEN],fname[ENV_MSGLEN],msg[ENV_MSGLEN];

	if((dir=opendir(WEATHER_DIR))==NULL)
	{
		sprintf(msg,"%s: Directory not found.",func_name);
		strcpy(rmsg,msg);
		return ENV_ERR;
	}
	closedir(dir);

	sprintf(fname,"%s/%s",WEATHER_DIR,RAINDROP_FILE);
	if((fp=fopen(fname,"rt"))==NULL)
	{
		sprintf(msg,"%s: File open error.",func_name);
		strcpy(rmsg,msg);
		return ENV_ERR;
	}

	fgets(buf,sizeof(buf),fp);
	fclose(fp);
	if(sscanf(buf,"1=%d,2=%d",&sensor1,&sensor2)!=2)
	{
		sprintf(msg,"%s: File format error.",func_name);
		strcpy(rmsg,msg);
		return ENV_ERR;
	}

	if(sensor1==RAIN_FALSE && sensor2==RAIN_FALSE)
		return RAIN_FALSE;
	else
		return RAIN_TRUE;
}

int chk_humidity()
{
	const char func_name[]="chk_humidity()";
	FILE	*fp;
	DIR	*dir;
	int	humidity;
	char	buf[ENV_MSGLEN],fname[ENV_MSGLEN],msg[ENV_MSGLEN];

	if((dir=opendir(WEATHER_DIR))==NULL)
	{
		sprintf(msg,"%s: Directory not found.",func_name);
		fprintf(stderr,msg);
		return ENV_ERR;
	}
	closedir(dir);

	sprintf(fname,"%s/%s",WEATHER_DIR,WEATHER36_FILE);
	if((fp=fopen(fname,"rt"))==NULL)
	{
		sprintf(msg,"%s: File open error.",func_name);
		fprintf(stderr,msg);
		return ENV_ERR;
	}

	while(fgets(buf,sizeof(buf),fp)!=NULL)
	{
		if(strncmp(buf,"Outside Humidity",16)==0)
		{
			if(sscanf(buf,"Outside Humidity: %d ",&humidity)!=1)
			{
				sprintf(msg,"%s: File format error.",func_name);
				fprintf(stderr,msg);
				fclose(fp);
				return ENV_ERR;
			}

			break;
		}
	}

	fclose(fp);
	return humidity;
}

int chk_humidity_msg(char rmsg[])
{
	const char func_name[]="chk_humidity()";
	FILE	*fp;
	DIR	*dir;
	int	humidity;
	char	buf[ENV_MSGLEN],fname[ENV_MSGLEN],msg[ENV_MSGLEN];

	if((dir=opendir(WEATHER_DIR))==NULL)
	{
		sprintf(msg,"%s: Directory not found.",func_name);
		strcpy(rmsg,msg);
		return ENV_ERR;
	}
	closedir(dir);

	sprintf(fname,"%s/%s",WEATHER_DIR,WEATHER74_FILE);
	if((fp=fopen(fname,"rt"))==NULL)
	{
		sprintf(msg,"%s: File open error.",func_name);
		strcpy(rmsg,msg);
		return ENV_ERR;
	}

	while(fgets(buf,sizeof(buf),fp)!=NULL)
	{
		if(strncmp(buf,"Outside Humidity",16)==0)
		{
			if(sscanf(buf,"Outside Humidity: %d ",&humidity)!=1)
			{
				sprintf(msg,"%s: File format error.",func_name);
				strcpy(rmsg,msg);
				fclose(fp);
				return ENV_ERR;
			}

			break;
		}
	}

	fclose(fp);
	return humidity;
}


