/* 
 * socket_client.c
 * 
 * 2004.11.23
 * Time-stamp: <2004-12-15 14:32:56 dimm>
 */
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "finder.h"

//#define SOCK_NAME       "/tmp/socket2"
#define PORT 8765

int connect_socket(char* hostname) {
  struct sockaddr_in    addr;
  struct hostent        *hp;
  int    len;

  if ((fd_socket = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    return(EXIT_FAILURE);
  }
  
  bzero((char *)&addr, sizeof(addr));

  if((hp=gethostbyname(hostname))==NULL) {
    perror("gethostbyname");
    return(EXIT_FAILURE);
  }
  bcopy(hp->h_addr,&addr.sin_addr,hp->h_length);
  addr.sin_family=AF_INET;
  addr.sin_port=htons(PORT);

  if (connect(fd_socket,(struct sockaddr *)&addr,sizeof(addr)) < 0) {
    perror("connect");
    return(EXIT_FAILURE);
  }

  return(EXIT_SUCCESS);
}

/* read dome status from socket */
int read_dome_status(void) {
  int ret, dome_status;
  char buf[1024], key[10];

  strcpy(key, "dome");
  write(fd_socket, key, sizeof(key));
  #ifdef DEBUG
  printf("# read_dome_status(): sent: %s.\n", key);
  #endif

  if (fd_socket < 0) {
    printf("ERROR in read_finder_coords: socket not connected.\n");
    return(-1);
  }

  ret = read(fd_socket, buf, sizeof(buf));
  printf("read from socket: %s\n",buf);

  dome_status = atoi(buf); /* 1:close 2:unknown 3:open */

  return(dome_status);
}

int write_finder_coords(void) {
  char buf[20];
  sprintf(buf, "f %d %d %d %d %d", mseemon.star_center[0].cx, mseemon.star_center[0].cy, mseemon.peakval[0], rainflg, humidity);

  write(fd_socket, buf, sizeof(buf));
  return(EXIT_SUCCESS);
}

int dome_open(void) {
  char key[10];
  strcpy(key, "dopen");

  write(fd_socket, key, sizeof(key));
  return(EXIT_SUCCESS);
}

int dome_close(void) {
  char key[10];
  strcpy(key, "dclose");

  write(fd_socket, key, sizeof(key));
  return(EXIT_SUCCESS);
}

int ccd_on(void) {
  char key[10];

  strcpy(key, "ccdon");
  write(fd_socket, key, sizeof(key));

  return(EXIT_SUCCESS);
}

int ccd_off(void) {
  char key[10];
  strcpy(key, "ccdoff");
  write(fd_socket, key, sizeof(key));
  return(EXIT_SUCCESS);
}

int reset_sio(void) {
  char key[10];
  strcpy(key, "reset");
  write(fd_socket, key, sizeof(key));
  return(EXIT_SUCCESS);
}

int disconnect_socket(void) {
  close(fd_socket);
  return(EXIT_SUCCESS);
}
